"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqlLanguageAdapter = void 0;
const languageAdapter_1 = require("../../../../language/infrastructure/adapters/base/languageAdapter");
const SqlDmlBuilder_1 = require("./SqlDmlBuilder");
const config_json_1 = __importDefault(require("./config.json"));
const ddlBuilder_1 = require("../../../../language/infrastructure/adapters/SQL/ddlBuilder");
class SqlLanguageAdapter extends languageAdapter_1.LanguageAdapter {
    constructor(helper) {
        super('SQL', config_json_1.default.dialects);
        this.helper = helper;
        this.solveComposite = false;
    }
    ddlBuilder(source, mapping) {
        return new ddlBuilder_1.SqlDDLBuilderAdapter(source, mapping, this.getDialect(source.dialect), this.helper);
    }
    dmlBuilder(source, mapping) {
        return new SqlDmlBuilder_1.SqlDMLBuilderAdapter(source, mapping, this.getDialect(source.dialect), this.helper);
    }
}
exports.SqlLanguageAdapter = SqlLanguageAdapter;
//# sourceMappingURL=language.js.map